--- /usr/sbin/checkrestart	2012-06-16 03:38:23.000000000 +0100
+++ checkrestart	2013-04-23 16:46:44.543793233 +0100
@@ -2,6 +2,7 @@
 
 # Copyright (C) 2001 Matt Zimmerman <mdz@debian.org>
 # Copyright (C) 2007,2011 Javier Fernandez-Sanguino <jfs@debian.org>
+# Copyright (C) 2013 Tiger Computing Ltd
 # - included patch from Justin Pryzby <justinpryzby_AT_users.sourceforge.net>
 #   to work with the latest Lsof - modify to reduce false positives by not
 #   complaining about deleted inodes/files under /tmp/, /var/log/,
@@ -59,7 +60,7 @@
      return 1
 
 def usage():
-    sys.stderr.write('usage: checkrestart [-vhpa] [-bblacklist] [-iignore]\n')
+    sys.stderr.write('usage: checkrestart [-vhpatn] [-bblacklist] [-iignore]\n')
 
 def main():
     global lc_all_c_env, file_query_check
@@ -75,7 +76,7 @@
 
 # Process options
     try:
-        opts, args = getopt.getopt(sys.argv[1:], "hvpab:i:", ["help", "verbose", "packages", "all", "blacklist", "ignore"])
+        opts, args = getopt.getopt(sys.argv[1:], "hvpab:i:tn", ["help", "verbose", "packages", "all", "blacklist", "ignore", "terse", "nagios"])
     except getopt.GetoptError, err:
         # print help information and exit:
         print str(err) # will print something like "option -x not recognized"
@@ -83,12 +84,16 @@
         sys.exit(2)
 
     # Global variables set through the command line
-    global verbose, onlyPackageFiles, allFiles
+    global verbose, onlyPackageFiles, allFiles, terseOutput, nagiosCodes
     verbose = False
     # Only look for deleted files that belong to packages
     onlyPackageFiles = False
     # Look for any deleted file
     allFiles = False
+    # Friendly output by default
+    terseOutput = False
+    # Exit codes for Nagios et al
+    nagiosCodes = False
 
     for o, a in opts:
         if o in ("-v", "--verbose"):
@@ -106,6 +111,10 @@
             onlyPackageFiles = False
         elif o in ("-i", "--ignore"):
             ignorelist.append(a)
+        elif o in ("-t", "--terse"):
+            terseOutput = True
+        elif o in ("-n", "--nagios"):
+            nagiosCodes = True
         else:
             assert False, "unhandled option"
 
@@ -130,6 +139,19 @@
 
     toRestart = lsofcheck(blacklist = blacklist)
 
+    if terseOutput:
+        terseoutput(toRestart)
+    else:
+        fulloutput(toRestart)
+
+def terseoutput(toRestart):
+    print "%d processes using old versions of upgraded files" % len(toRestart)
+    if nagiosCodes:
+        # 0 OK, 1 warning, 2 critical, 3 unknown
+        # we only care for 0 or 1
+        sys.exit(1) if len(toRestart) else sys.exit(0)
+
+def fulloutput(toRestart):
     print "Found %d processes using old versions of upgraded files" % len(toRestart)
 
     if len(toRestart) == 0:
